//////////////////////////////
// VIMEO functions for CADET
//////////////////////////////
var VimeoPlayer = {};


    VimeoPlayer.player = null;
    VimeoPlayer.paused = true;
    VimeoPlayer.time = 0.0;
    		
	
	VimeoPlayer.createPlayer = function createPlayer(vidid, w, h){
		/**/
		//var mywidth=640, myheight=390;
		var mywidth="100%", myheight="auto";
		if(typeof w !== 'undefined')
			mywidth = w;
		if(typeof h !== 'undefined')
			myheight = h;
		
		var options = {
			id: vidid,
			width: mywidth, //640
			height: myheight,//390
			portrait: 0,
			loop: false
		};


		if( VimeoPlayer.player )
			VimeoPlayer.player.destroy();
		VimeoPlayer.player = new Vimeo.Player('remoteSubstitute', options);
		
		VimeoPlayer.player.on('timeupdate', function(data) {
			// data is an object containing properties specific to that event
			VimeoPlayer.time = data.seconds;
			doDebug("playerVimeo: timeupdate event")
		});		
		VimeoPlayer.player.on('pause', function(data) {
			// data is an object containing properties specific to that event
			VimeoPlayer.paused = true;
			doDebug("playerVimeo: paused event");
		});		
	}

	function loadVideo(myvidid) {
		//videoId = document.getElementById('vidid').value;
		//alert("vidid=["+videoId+"]");
		//debug("playerYT: loadVideo called with vidid=["+myvidid+"]");

		VimeoPlayer.videoId = myvidid;//save the videoId
		VimeoPlayer.createPlayer(myvidid);

	}//loadVideo

	
	function unloadVideo() {
		if( VimeoPlayer.player ){
			VimeoPlayer.player.destroy().then(function() {
				// the player was destroyed
			}).catch(function(error) {
				//some other error
			});	
		}	
		VimeoPlayer.player = null;
		return null ;
	}//unloadVideo
	
	
VimeoPlayer.play = function(){
	if( VimeoPlayer.player ) VimeoPlayer.player.play();
};
VimeoPlayer.pause = function(){
	if( VimeoPlayer.player ) VimeoPlayer.player.pause();
};
VimeoPlayer.stop = function(){
	if( VimeoPlayer.player ) VimeoPlayer.player.stop();
}//stop
VimeoPlayer.getTime = function(){
	return VimeoPlayer.time;
	//var time;
	if( VimeoPlayer.player ){
     	VimeoPlayer.player.getCurrentTime().then(function(time) {
			// time = the current playback position
			//return time;
			PlayerDispatch.setUItime(time);
		}).catch(function(error) {
			// an error occurred
			return 0.0
		});
	}
}//getTime

VimeoPlayer.cueMedia = function(s){
	if( VimeoPlayer.player ){
		VimeoPlayer.player.setCurrentTime(s);
	}
}//cueMedia

VimeoPlayer.loadVideo = loadVideo;
VimeoPlayer.unloadVideo = unloadVideo;

VimeoPlayer.isPlaying = function(){
	if( VimeoPlayer.player ){

		VimeoPlayer.player.getPaused().then(function(paused) {
			// paused = whether or not the player is paused
			return !paused;
		}).catch(function(error) {
			// an error occurred
		});
		
	} else {
		return false;
	}
}//isPlaying

VimeoPlayer.isPaused = function(){
	if( VimeoPlayer.player ){
		return VimeoPlayer.paused;

		VimeoPlayer.player.getPaused().then(function(paused) {
			// paused = whether or not the player is paused
			doDebug("playerVimeo: isPaused: must be paused")
			return paused;
		}).catch(function(error) {
			// an error occurred
		});
		
	} else {
		return true;
	}
}//isPaused

VimeoPlayer.playPauseMedia = function(){
	VimeoPlayer.player.getPaused().then(function(paused) {
		// paused = whether or not the player is paused
		//alert("isPaused returning ["+paused+"]");
		if( paused ){
			//doStatus("PAUSE-to-PLAY TOGGLE SETTING readInitial=false");
			readInitial = false;
			readLast = false;

			if( _editMode == EDITMODE_REVIEW ){
				//cueIntime(_currentRow);
			}
			VimeoPlayer.play(); 
									
		} else {
			bSpecialPlay = false;	//undo specialPlay sensing if pausing
			//kill whatever TTS is playing
			ttsCancel();//responsiveVoice.cancel();
	
			//doStatus("PLAY/PAUSE TOGGLE SETTING readInitial=false");
			readInitial = false;
			readLast = false;

			VimeoPlayer.pause(); 
		}
		
	}).catch(function(error) {
		// an error occurred
	});
	
}//playPauseMedia
VimeoPlayer.playPauseMediaSpecial = function(){
	VimeoPlayer.player.getPaused().then(function(paused) {
		// paused = whether or not the player is paused
		//alert("isPaused returning ["+paused+"]");
		if( paused ){
			//doStatus("PAUSE-to-PLAY TOGGLE SETTING readInitial=false");
			readInitial = false;
			readLast = false;

			if( _editMode == EDITMODE_REVIEW ){
				//cueIntime(_currentRow);
			}
			VimeoPlayer.play();
									
		} else {
			bSpecialPlay = false;	//undo specialPlay sensing if pausing
			//kill whatever TTS is playing
			ttsCancel();//responsiveVoice.cancel();
	
			//doStatus("PLAY/PAUSE TOGGLE SETTING readInitial=false");
			readInitial = false;
			readLast = false;

			VimeoPlayer.pause(); 
		}
		
	}).catch(function(error) {
		// an error occurred
	});
		
}//playPauseMediaSpecial

VimeoPlayer.setPlayerSpeed = function(x){
	if( VimeoPlayer.player ){
		VimeoPlayer.player.setPlaybackRate(x).then(function(playbackRate) {
		  // The playback rate is set
		}).catch(function(error) {
		  switch (error.name) {
			case 'RangeError':
				// The playback rate is less than 0.5 or greater than 2
				break;

			default:
				// Some other error occurred
				//probably the video owner is not Pro so no speed control
				break;
		  }
		});
	}
}//setPlayerSpeed

VimeoPlayer.resizePlayer = function(w,h){

	//YTplayer.player.setSize(w,h);	
	return;
}//resizePlayer

VimeoPlayer.mediaJump = function(bhow, inc){
	//get the current time and jump from there
	if( VimeoPlayer.player ){
		var time = VimeoPlayer.time;
		if( bhow ){	//forward
			VimeoPlayer.cueMedia(time + inc); //forward
		} else {		//reverse
			if( time - inc >= 0.0 )
				VimeoPlayer.cueMedia(time - inc); //reverse
			else
				VimeoPlayer.cueMedia(0.0); //reverse
		}
	}
	return;
}//mediaJump

